#ifndef LIFEGAMETHREAD_H
#define LIFEGAMETHREAD_H

#include <QThread>
#include <QMutex>

#include <QString>

#include <boost/shared_array.hpp>
#include <boost/shared_ptr.hpp>
#include <vector>

class StepThread;

namespace LifeGame{

const int DNAWidth = 8;
const int DNAHeight = 6;

const int Population = 100;

struct DNA{
    DNA();
    ~DNA();

    // ˑRψ
    void mutate(DNA* dst, float pr) const;

    // 2_
    void crossOver(DNA* dst, const DNA& other) const;

    // ̂܂܃Rs[
    void clone(DNA* dst) const;

    boost::shared_array<int> genes_;
};

}

class LifegameThread : public QThread
{
    Q_OBJECT
public:
    explicit LifegameThread(QObject *parent = 0);
    ~LifegameThread();

    int bestAliveNum();
    LifeGame::DNA bestDNA();
    LifeGame::DNA bestDNA2();

    LifeGame::DNA randomPredator();
    LifeGame::DNA randomProducer();

    void stop();

protected:
    virtual void run();

signals:
    void sendMessage(const QString&);

public slots:

private:
    void generateNextGeneration();

private:

    int generation_;

    // Oƌ㔼ŃXbvď
    int swapIndex_;
    LifeGame::DNA predators_[LifeGame::Population*2];
    LifeGame::DNA producers_[LifeGame::Population*2];

    float results_[LifeGame::Population];
    float results2_[LifeGame::Population];
    float probabilities_[LifeGame::Population];
    float probabilities2_[LifeGame::Population];

    std::vector<StepThread*> threads_;

    float bestAliveNum_;
    LifeGame::DNA bestDNA_;

    float bestAliveNum2_;
    LifeGame::DNA bestDNA2_;

    bool stopFlag_;

    QMutex mutex_;
};

#endif // LIFEGAMETHREAD_H
