#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>

class LifegameThread;
class StepThread;

class QTextEdit;

class PanelWidget : public QWidget{
    Q_OBJECT
public:
    PanelWidget(StepThread* step, QWidget *parent = 0);

protected:
    virtual void paintEvent(QPaintEvent *);

private:
    StepThread* step_;
public:
    int stepCount_;
};

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

protected:
    virtual void mousePressEvent(QMouseEvent *);
    virtual void keyPressEvent(QKeyEvent *);

    virtual void paintEvent(QPaintEvent *);

    virtual void timerEvent(QTimerEvent *);

private:
    PanelWidget* panel_;
    QTextEdit* textArea_;

    LifegameThread* thread_;
    StepThread* step_;

    bool autoStep_;
    int timerID_;
    int stepCount_;
};

#endif // MAINWINDOW_H
