#ifndef STEPTHREAD_H
#define STEPTHREAD_H

#include <QThread>

#include <boost/shared_array.hpp>

void initializePixImage();

class QPainter;

class StepThread : public QThread
{
    Q_OBJECT
public:
    explicit StepThread(QObject *parent = 0);

    int aliveNum() const;
    int eatenNum() const;
    int alivePredatorNum() const;
    int aliveProducerNum() const;

    void setStepSize(int stepSize);
    void setWidth(int width);
    void setHeight(int height);

    void resetField();

    void randomSeed();

    void setSeed(const boost::shared_array<int>& seed, int type, int x, int y, int width, int height);

    void draw(QPainter* painter) const;

protected:
    virtual void run();

signals:

public slots:

private:
    int nextState(int x, int y);

private:
    int width_;
    int height_;

    int oldWidth_;
    int oldHeight_;

    int stepSize_;
    int eat_;

    boost::shared_array<int> cells_;
    boost::shared_array<int> tmp_;
};

#endif // STEPTHREAD_H
